Subject: Re: linux-next: add utrace tree

From: "Frank Ch. Eigler" <[email-masked]>
Date: Fri, 22 Jan 2010 17:13:48 -0500

Hi -

On Fri, Jan 22, 2010 at 01:59:11PM -0800, Linus Torvalds wrote:
> [...]
> > Finally, I don't know how to address the logic of "if a feature
> > requires utrace, that's a bad argument for utrace" and at the same
> > time "you need to show a killer app for utrace".  What could possibly
> > satisfy both of those constraints?  Please advise.
> 
> The point is, the feature needs to be a killer feature. And I have yet to 
> hear _any_ such killer feature, especially from a kernel maintenance 
> standpoint.

> The "better ptrace than ptrace" is irrelevant. Sure, we all know ptrace 
> isn't a wonderful feature. But it's there, and a debugger is going to have 
> support for it anyway, so what's the _advantage_ of a "better ptrace 
> interface"? There is absolutely _zero_ advantage, there's just "yet 
> another interface". We can't get rid of the old one _anyway_.

The point is that the intermediate api will allow (and, as the part
you clipped out about utrace-gdbstub said, *already has allowed*)
alternative plausible interfaces that coexist just fine.

> And the seccomp replacement just sounds horrible. Using some tracing 
> interface to implement security models sounds like the worst idea ever.

So all this is about *naming* utrace?  It was never built "for
tracing", but for (efficient/multiplexed) *control*.  That wasn't even
its original name -- one of your lieutenants asked roland to change it
to utrace.

> And like it or not, over the last almost-decade, _not_ having to
> have to work with system tap has been a feature, not a problem, for
> the kernel community.

I don't have a problem with that.  We have apprx. never imposed
anything on developers who didn't want to use it.  There are plenty
who have and will.

- FChE